{ 06If - Example program from http://www.SoftwareForEducation.com/ }

{  EXAMPLE   Decision making using IF.

             The top button makes the form go red.
             No decision is made.

             The second button makes the form go green
             but only if the colour was red first.

             Third button.
             If the form was red, make it go green.
             If the form was green, make it go yellow.
             If the form was yellow, make it go red.
             Don't respond to any other colour.

   TASK      Add a fourth button.  Make it change the
             colours in any way you like to design.
             Use on-line help to find out what colours
             are available.  Use the following ...

             Help | Topic Search
             Type in TColor
             Press enter twice.
             Click on TColor
             Click on Color Property                                  }
unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{ ===================================================================
  This procedure runs when Button1 is clicked.

  Input           : None.
  Process         : Set form colour to red.
  Test data       : None.
  Expected Output : A red form.
  Actual output   : A red form.
  Action needed   : None.  The procedure works correctly.  }

procedure TForm1.Button1Click(Sender: TObject);
begin
  Form1.color := clRed;
end;

{ ===================================================================
  This procedure runs when Button2 is clicked.

  Input           : None.
  Process         : If the form is red then make it green.
                    Do nothing otherwise.
  Test data       : None.
  Expected Output : A green form if the form was red.
                    None if the form was any other colour.
  Actual output   : As expected.
  Action needed   : None.  The procedure works correctly.  }

procedure TForm1.Button2Click(Sender: TObject);
begin
  if Form1.color = clRed then
  begin
    Form1.color := clGreen
  end
end;

{ ===================================================================
  This procedure runs when Button3 is clicked.

  Input           : None.
  Process         : If the form is red then make it green.
                    If the form is green then make it yellow.
                    If the form is yellow then make it red.
                    If the form is any other colour then do nothing.
  Test data       : None.
  Expected Output : Form colour changes according to the rules above.
  Actual output   : As expected.
  Action needed   : None.  The procedure works correctly.  }

procedure TForm1.Button3Click(Sender: TObject);
begin
  if Form1.color = clRed then
  begin
    Form1.color := clGreen
  end
  else if Form1.color = clGreen then
  begin
    Form1.color := clYellow
  end
  else if Form1.color = clYellow then
  begin
    Form1.color := clRed
  end

end;

end.

