{ Advanced\CantRun - Example program from http://www.SoftwareForEducation.com/ }

{
    EXAMPLE    A program where ... only one instance can run.
               This technique only works with Win 3.

               hPrevInst is a Delphi System unit variable.  It is set to 0
               (nought) if the is no previous instance of the program running.

               The value of hPrevInst can be used to detect is there is
               a previous instance of an application running.

               This example uses hPrevInst to decide whether to run or not.
               If there is a previous instance, this program will give an error
               message and close itself down again.

               This technique can be used to prevent multiple screen saver
               instances from starting up.

    TASK       Use this technique if you need it.
}

unit Cant_f;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormActivate(Sender: TObject);
begin
  { hPrevInst will be 0 if this is the first
    instance of this program running. }
  if hPrevInst <> 0 then
  begin
    messageDlg('Can''t run a second instance of this program.', mtError, [mbOK], 0);
    close
  end
end;

end.

